#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"

#define RQ_SET_LED    0
#define RQ_GET_SWITCH 1
#define RQ_GET_Light  2
#define RQ_SET_7SEG   3

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

int i=0,j=0,k=0,z=0;
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    i=rq->wValue.bytes[0];
    j=rq->wValue.bytes[1];
    k=rq->wIndex.bytes[0];
    z=rq->wIndex.bytes[1];
    return 0;
}

/* ------------------------------------------------------------------------- */

int main(void)
{
    DDRC  = (1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3)|(1<<PC4|(1<<PC5)); // PC0..PC2 = Output, PC3..PC5 = Input
    DDRB  = (1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3)|(1<<PC4|(1<<PC5)); // PC0..PC2 = Output, PC3..PC5 = Input
    //PORTC = (1 << PC3);               // Enable pull-up at PC3

    usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();

    /* enable global interrupts */
    sei();

    /* main event loop */
    for(;;)
    {
        usbPoll();
        PORTC =0+ i;
        _delay_ms(0.5);
        PORTC =32+ j;
        _delay_ms(0.5);
        PORTC =16 + k;
        _delay_ms(0.5);
        PORTB = z;
        
    }

    return 0;
}

/* ------------------------------------------------------------------------- */
